-- ========== GENERATED BY PlayStationActivities Editor DO NOT EDIT MANUALLY! ==========

PlaceObj('PlayStationActivities', {
	Launch = function (self)
		if self:IsActive() and Game and Game.Campaign == self.id then
			return -- We are in a game with the activity's campaign. Nothing to do here.
		end
		
		local pre_game_menu = GetDialog("PreGameMenu")
		if pre_game_menu and pre_game_menu.Mode == "NewGame" then
			return  -- We are in the new game interface. Nothing to do here.
		end
		
		CreateRealTimeThread(function()
			local save_load_obj = g_SaveGameObj or SaveLoadObjectCreateAndLoad()	
			if not save_load_obj.initialized then
				LoadingScreenOpen("idLoadingScreen", "launching activity")
				save_load_obj:WaitGetSaveItems()
				LoadingScreenClose("idLoadingScreen", "launching activity")
			end
			
			local latest_saves = {}
			for _, save in ipairs(save_load_obj.items) do
				local metadata = save.metadata
				if not CanLoadSave(save) or not metadata.campaign then
					goto continue
				end
				if Platform.desktop then -- Skip test saves
					local save_path  = ConvertToOSPath(GetSavePath(save.savename))
					save_path = save_path:gsub("\\", "/")
					if save_path:find("TestSaves/") then
							goto continue
					end
				end
				if not latest_saves[metadata.campaign] then
					latest_saves[metadata.campaign] = save
				elseif latest_saves[metadata.campaign].metadata.timestamp < metadata.timestamp then
					latest_saves[metadata.campaign] = save
				end
				::continue::
			end
		
			local pre_game_menu = GetDialog("PreGameMenu")
			if pre_game_menu and pre_game_menu.Mode == "NewGame" then
				return  -- We are in the new game interface. Nothing to do here.
			end
				
			if latest_saves[self.id] then
				while not CanLoadGame() do
					Sleep(1)
				end
				g_AutoClickLoadingScreenStart = 0
				save_load_obj:Load(nil, latest_saves[self.id], Platform.developer)
				return
			end
			
			table.find_value(GameStartTypes, "id", "Campaign").func()
		end)
	end,
	category = "progress",
	default_playtime_estimate = 3000,
	description = T(299521549240, --[[PlayStationActivities HotDiamonds description]] 'Grand Chien, a nation of rich natural resources and deep political divides, is thrown into chaos when the elected president goes missing and a paramilitary force known as "The Legion" seizes control of the countryside. Your team of mercs has been hired to resolve the situation.'),
	group = "Campaign",
	id = "HotDiamonds",
	is_required_for_completion = true,
	msg_reactions = {
		PlaceObj('MsgReaction', {
			Event = "CampaignStarted",
			Handler = function (self, campaign_id)
				if not (Platform.developer or Platform.ps5) or campaign_id ~= self.id then return end
				if not self:IsActive() then
					self:Start()
				end
			end,
		}),
		PlaceObj('MsgReaction', {
			Event = "ZuluGameLoaded",
			Handler = function (self, game)
				if not (Platform.developer or Platform.ps5) then return end
				local campaign_id = Game and Game.Campaign or rawget(_G, "DefaultCampaign") or "HotDiamonds"
				if campaign_id == self.id and not self:IsActive() then
					self:Start()
				elseif campaign_id ~= self.id and self:IsActive() then
					self:Abandon()
				end
			end,
		}),
		PlaceObj('MsgReaction', {
			Event = "CampaignEnd",
			Handler = function (self, campaign_id)
				if not (Platform.developer or Platform.ps5) or campaign_id ~= self.id then return end
				if self:IsActive() then
					self:Complete()
				end
			end,
		}),
	},
	title = T(285490426661, --[[PlayStationActivities HotDiamonds title]] "Hot Diamonds"),
})

